cc For 3D version
c      SUBROUTINE DATA(NMTE,ECON,T,NN,X,Y,Z
c     + ,IFOR,FB,IDIS,UB,NGNG,NOM,IECON,NEUS,NNUS,NSMALL,NSNODE,NKIND)
      SUBROUTINE DATA
      use fem_arrays
      implicit integer (i-n)
      implicit double precision (a-h,o-z)     
c      
c      INCLUDE 'const.inc'
c      INCLUDE 'femcg.inc'
c     DIMENSION NMTE(*),NN(INMTE,*),X(*),Y(*),Z(*),IFOR(*),IDIS(*)
cccc modified 98-09-12
c
      OPEN(1,FILE=fnum(3),status='unknown')
C     CHARACTER *1 A(72)
C     READ(5,1)A
C     1 FORMAT(72A1)
C     WRITE(6,1)A
      READ(1,*)NGAUSS
c MNUM : kind of materials
      READ(1,*)MNUM
C+++++++++++++++++++++++++++++++++++++
      write(77,*)'DATA CHECK'
      write(77,*)'NUMBER OF MATERIAL =   ',MNUM
      write(77,*)'INTEGRATION ORDER =    ',NGAUSS
C+++++++++++++++++++++++++++++++++++++
      allocate (ECON(9,mnum))
      allocate (IECON(mnum))
c
C     READ(1,*)NPARA,T,MNUM
C--ANALYSIS CONDITION------------
C NPARA=0 --> PLANE STRESS
C NPARA=1 --> PLANE STRAIN
C NPARA=2 --> AXIAL SYMMETRY
C--------------------------------
C*ELASTIC CONSTANTS 
C  IECON = 1 --> ISOTROPIC
C    ECON(1,L)=YOUNG MODULE , ECON(2,L)=POISSON RATIO
C  IECON = 2 --> ANISOTROPIC
C    ECON(1,L)=C11 ECON(2,L)=C22 ECON(3,L)=C33 ECON(4,L)=C44 
C    ECON(5,L)=C55 ECON(6,L)=C66 ECON(7,L)=C12 ECON(8,L)=C13 
C    ECON(9,L)=C23  12->4 13->5 23->6
C
c
      DO 5 L=1,MNUM
	 READ(1,*)IECON(L)
         IEC = IECON(L)
	 IF (IEC.EQ.1)  THEN
            READ(1,*)MN,ECON(1,L),ECON(2,L)
C+++++++++++++++++++++++++++++++++++++
          write(77,*)'Material',L
          write(77,*)'YOUNG=',ECON(1,L),', POISSON=',ECON(2,L)
C+++++++++++++++++++++++++++++++++++++
         ELSE
	 IF (IEC.EQ.2)  THEN
           READ(1,*)MN,ECON(1,L),ECON(2,L),ECON(3,L)
     +                ,ECON(4,L),ECON(5,L),ECON(6,L)
     +                ,ECON(7,L),ECON(8,L),ECON(9,L)
C+++++++++++++++++++++++++++++++++++++
          write(77,*)'Material',L
      write(77,*)'C11=',ECON(1,L),', C22=',ECON(2,L),', C33=',ECON(3,L)
      write(77,*)'C44=',ECON(4,L),', C55=',ECON(5,L),', C66=',ECON(6,L)
      write(77,*)'C12=',ECON(7,L),', C13=',ECON(8,L),', C23=',ECON(9,L)
         ENDIF
         ENDIF
 5    CONTINUE
      READ(1,*)NTN,NTE
c--------------------------------------
c NTN : NUMBER OF NODE
c NTE : NUMBER OF ELEMENT
c NTF : NUMBER OF FREEDOM
c NNA : NUMBER OF INTEGRATION POINT
c--------------------------------------
      NTF=NTN*IDIM
C+++++++++++++++++++++++++++++++++++++++++
      write(77,*)'TOTAL NODES    =   ',NTN
      write(77,*)'TOTAL ELEMENTS =   ',NTE
      write(77,*)'TOTAL FREEDOMS =   ',NTF
C+++++++++++++++++++++++++++++++++++++++++
      allocate(nmte(nte),nn(inmte,nte),ngng(nte),nom(nte),nkinf(nte),
     &         neus(nte))
      allocate(coord(3,ntn),nnus(ntn))
ccccc for ICCG method
      allocate(nsmall(ntn),nsnode(ntn,inmte*10))
c
      NNA=0
      DO 20 IE=1,NTE
ccc inifinite element
         READ(1,*)II,NOM(IE),NMTE(IE),NKINF(IE)
cc         READ(1,*)II,NOM(IE),NMTE(IE)
c*SORT IE : PROGRAM ELEMENT NUMBER , NEUS(IE) : USER ELEMENT
         NEUS(IE)=II
c---- 6 nodes sankaku-tyu
         IF(NMTE(IE).EQ.6) THEN
          IF (NGAUSS.EQ.1) NGNG(IE)=2
          IF (NGAUSS.EQ.2) NGNG(IE)=6
           READ(1,*)NN(1,IE),NN(2,IE),NN(3,IE),NN(4,IE),
     +              NN(5,IE),NN(6,IE)
C++++++++++++++++++++++++++++++++++++++++
          write(77,*)'ELEMENT',IE,':  MATERIAL',NOM(IE)
     +                                ,' : 6 NODES sankaku-tyuu'
C+++++++++++++++++++++++++++++++++++++++++
c---- 15 nodes sankaku-tyu
         ELSE IF(NMTE(IE).EQ.15) THEN
           READ(1,*)NN(1,IE),NN(2,IE),NN(3,IE),NN(4,IE),
     +              NN(5,IE),NN(6,IE),NN(7,IE),NN(8,IE), 
     +              NN(9,IE),NN(10,IE),NN(11,IE),NN(12,IE), 
     +              NN(13,IE),NN(14,IE),NN(15,IE) 
c******* NGAUSS= 2 or 3
          IF (NGAUSS.EQ.2) NGNG(IE)=6
          IF (NGAUSS.EQ.3) NGNG(IE)=12             
C++++++++++++++++++++++++++++++++++++++++
          write(77,*)'ELEMENT',IE,':  MATERIAL',NOM(IE)
     +                      ,' : 15 NODES sankaku-tyuu'
C+++++++++++++++++++++++++++++++++++++++++
c---- 8 nodes 8-men-tai
         ELSE IF(NMTE(IE).EQ.8) THEN
           READ(1,*)NN(1,IE),NN(2,IE),NN(3,IE),NN(4,IE),
     +              NN(5,IE),NN(6,IE),NN(7,IE),NN(8,IE) 
cccc modified 98-09-08 
           DO 555 K = 1,8
              NK = NN(K,IE)
              DO 556 KK = 1,8
                NK2 = NN(KK,IE)
c                write(6,*)NK,NK2
                 IF (NK2.LT.NK) THEN
                    NS = NSMALL(NK)
                    IF (NS.EQ.0) goto 558
                    DO 557 JJ = 1,NS
                       IF (NK2.EQ.NSNODE(NK,JJ)) goto 559
 557                CONTINUE
 558                CONTINUE
                    NSMALL(NK) = NSMALL(NK) + 1
                    NSNODE(NK,NSMALL(NK)) = NK2
c                   write(6,*)NK,NSMALL(NK),NK2
                    ENDIF
 559                CONTINUE
 556                CONTINUE
 555                CONTINUE
c
c******* NGAUSS= 2 or 3
           NGNG(IE)=NGAUSS*NGAUSS*NGAUSS
C++++++++++++++++++++++++++++++++++++++++
          write(77,*)'ELEMENT',IE,':  MATERIAL',NOM(IE)
     +                               ,' : 8 NODES 8-mentai'
C+++++++++++++++++++++++++++++++++++++++++
c---- 20 nodes 8-men-tai
         ELSE IF(NMTE(IE).EQ.20) THEN
           READ(1,*)NN(1,IE),NN(2,IE),NN(3,IE),NN(4,IE),
     +              NN(5,IE),NN(6,IE),NN(7,IE),NN(8,IE),
     +              NN(9,IE),NN(10,IE),NN(11,IE),NN(12,IE), 
     +              NN(13,IE),NN(14,IE),NN(15,IE),NN(16,IE),
     +              NN(17,IE),NN(18,IE),NN(19,IE),NN(20,IE)  
c******* NGAUSS= 2 or 3
           NGNG(IE)=NGAUSS*NGAUSS*NGAUSS 
C+++++++++++++++++++++++++++++++++++++++++         
          write(77,*)'ELEMENT',IE,':  MATERIAL',NOM(IE)
     +                               ,' : 20 NODES 8-mentai'
C+++++++++++++++++++++++++++++++++++++++++         
         ENDIF
         NNA=NNA+NGNG(IE)
 20   CONTINUE
cccc modified 98-09-08
            DO 560 I = 1,NTN
            NALL2 = NSMALL(I)
            DO 222 IK = 1,NALL2
               IW = IK
               DO 333 JJ = IK+1,NALL2
                 IF (NSNODE(I,JJ).LT.NSNODE(I,IW)) THEN
                  IW = JJ
                 ENDIF
 333           CONTINUE
               XX_N = NSNODE(I,IW)
               NSNODE(I,IW) = NSNODE(I,IK)
               NSNODE(I,IK) = XX_N
 222        CONTINUE
c            WRITE(997,1212)I,NSMALL(I),(NSNODE(I,J),J=1,NALL2)
 560        CONTINUE
 1212       format(20I5)
cccc modified 98-09-08
C+++++++++++++++++++++++++++++++++++++++++
        write(77,*)'TOTAL INT.POINTS =   ',NNA
        write(77,*)'COORDINATE OF NODES'
        write(77,*)'PRO.NUM. , USR NUM. ,COORDINATION OF NODE'
C+++++++++++++++++++++++++++++++++++++++++         
      DO 40 I=1,NTN
c         READ(1,*)JJ,X(I),Y(I),Z(I)
         READ(1,*)JJ,coord(1,I),coord(2,I),coord(3,I)
         write(77,112)I,JJ,coord(1,I),coord(2,I),coord(3,I)
C*SORT I : PROGRAM NODE NUMBER , NNUS(I) : USER NODE NUMBER
         NNUS(I)=JJ
 40   CONTINUE
C+++++++++++++++++++++++++++++++++++++++++
 112  format(2(I4,x),3e15.7)
c      
      WRITE(77,*)'*ELEMENT NODE IS RECONSTRUCTED'
c
      DO 200 IE=1,NTE
        NMIE=NMTE(IE)
        WRITE(77,*)'USER   ',(NN(J3,IE),J3=1,NMIE)
c
       DO 210 J2 = 1,NMIE
        NNJ2 = NN(J2,IE)
        DO 220 I2 = 1,NTN
           KK = NNUS(I2)
           IF ( KK.EQ.NNJ2 ) THEN
            NN(J2,IE) = I2
           GO TO 210
           ENDIF
 220    CONTINUE
          WRITE(6,*)'NO MATCH'
          STOP
 210    CONTINUE
        WRITE(77,*)'PROGRAM',(NN(J3,IE),J3=1,NMIE)
 200    CONTINUE
c
      WRITE(77,*)'*FORCE BOUNDARY'
c
      READ(1,*)NTFOR
      allocate (ifor(ntfor))
      allocate (fb(ntfor))
c
      IF(NTFOR.LT.1) GO TO 51
      DO 50 I=1,NTFOR
         READ(1,*)IFO,IXY,FF
c  IFO(USER NODE NUMBER) --> IFOP(PROGRAM NODE NUMBER)
         DO 55 I2 = 1,NTN
           KK=NNUS(I2)            
         IF ( KK.EQ.IFO ) THEN
           IFOP=I2
           GO TO 56
         ENDIF
 55      CONTINUE
            WRITE(77,*)'INVALID BOUNDARY CONDITION!(NO NODE)'
            WRITE(6,*)'ERROR!!'
            STOP
 56      CONTINUE
c         WRITE(6,*)IFO,IFOP
c------------------------------------------
         IF (IXY.GT.IDIM) THEN
            WRITE(77,*)'INVALID BOUNDARY CONDITION!(IXY.GT.IDIM)'
            WRITE(6,*)'ERROR'
            GO TO 51
         ENDIF
         NFREE = (IFOP-1)*IDIM + IXY
          IFOR(I)=NFREE
          FB(I) = FF
          IF (IXY.EQ.1) WRITE(77,*)'NODE',IFO,'-->FX=',FB(I),NFREE
          IF (IXY.EQ.2) WRITE(77,*)'NODE',IFO,'-->FY=',FB(I),NFREE
          IF (IXY.EQ.3) WRITE(77,*)'NODE',IFO,'-->FZ=',FB(I),NFREE
c
 50   CONTINUE
 51   CONTINUE
c
      WRITE(77,*)'*DISPLACEMENT BOUNDARY'
      READ(1,*)NTDIS
      allocate (idis(ntdis))
      allocate (ub(ntdis))
c
      IF(NTDIS.LT.1) GO TO 61
      DO 60 I=1,NTDIS
         READ(1,*)IDI,IXY,UU
c  IDI(USER NODE NUMBER) --> IDIP(PROGRAM NODE NUMBER)
         DO 65 I2 = 1,NTN
           KK=NNUS(I2)            
         IF ( KK.EQ.IDI ) THEN
           IDIP=I2
           GO TO 66
         ENDIF
 65      CONTINUE
            WRITE(77,*)'INVALID BOUNDARY CONDITION!(NO NODE)'
            WRITE(6,*)'ERROR!!'
            STOP
 66      CONTINUE
c         WRITE(6,*)IDI,IDIP
c------------------------------------------
         IF (IXY.GT.IDIM) THEN
            WRITE(77,*)'INVALID BOUNDARY CONDITION!(IXY.GT.IDIM)'
            WRITE(6,*)'ERROR'
            GO TO 61
         ENDIF
         NFREE = (IDIP-1)*IDIM + IXY
          IDIS(I)=NFREE
          UB(I) = UU
          IF (IXY.EQ.1) WRITE(77,*)'NODE',IDI,'-->UX=',UB(I)
     &                              ,'FREEDOM=',NFREE
          IF (IXY.EQ.2) WRITE(77,*)'NODE',IDI,'-->UY=',UB(I)
     &                              ,'FREEDOM=',NFREE
          IF (IXY.EQ.3) WRITE(77,*)'NODE',IDI,'-->UZ=',UB(I)
     &                              ,'FREEDOM=',NFREE
 60   CONTINUE
 61   CONTINUE
c
cccc FOR EQUATION
c  NAEQ : NUMBER OF EQUATION
c     NEQB : ROOT FREEDOM
c     NTEQ : NUMBER OF COPY FREEDOM
c     NEQ  : COPY FREEDOM
c
      READ(1,*)NAEQ
      IF (NAEQ.EQ.0) goto 88
      DO 80 I = 1,NAEQ
      READ(1,*)NEQB(I),NTEQ(I)
      READ(1,*)(NEQ(I,J),J=1,NTEQ(I))
 80   CONTINUE
 88   CONTINUE
c
ccc parameter for iccg method
      read(1,*)FCON,DCON,EPS
      read(1,*)MITR,NITR,isel,err
      write(77,*)'FCON,DCON,EPS=',FCON,DCON,EPS
      write(77,*)'MITR,NITR,isel,err=',MITR,NITR,isel,err
ccc
      CLOSE(1)
c
      CALL BAND  !   CALL BAND(NN,NMTE)
c
      nrd = maxval(ngng)
      write(6,*)'max. number of int. point in a element(nrd)=',nrd
      allocate (axi(nrd),aeta(nrd),azeta(nrd),h(nrd))

      nnmte = maxval(nmte)
      write(6,*)'max. number of node in a element(nnmte)=',nnmte
      allocate(shn(nnmte),dndxi(nnmte),dndeta(nnmte),dndzeta(nnmte))
      allocate(shnif(nnmte),dxif(nnmte),detif(nnmte),dzeif(nnmte))
c
      nnmnm  = nnmte * idim  
      write(6,*)'max. number of freedom in a element(nnmnm)=',nnmnm
      allocate(b(icom,nnmnm))
      allocate(ek(nnmnm,nnmnm),gk(ntf,nb),f(ntf),u(ntf))
c
      allocate(bm(nna,icom,nnmnm))
      allocate(c(nnmnm,nnmnm))
      allocate(bt(nnmnm,icom),btd(nnmnm,icom))
c
      allocate(ep(icom,nte,nrd),sg(icom,nte,nrd))
      allocate(sgn(icom,ntn),epn(icom,ntn))
c
      allocate(nf(nnmnm))
      allocate(nsgav(ntn))
c
ccccc for ICCG method
      allocate(syk(nb*ntf))
      allocate(diag(ntf),dd(ntf),t1(ntf),t2(ntf),t3(ntf),t4(ntf))
      allocate(index2(ntf),index5(ntn*nnmte*10),nsum(ntn))
      allocate(iwk(ntf))
c
      RETURN
      END
c
      SUBROUTINE BAND
      use fem_arrays
      implicit integer (i-n)
      implicit double precision (a-h,o-z)
c      INCLUDE 'para.inc'
c      INCLUDE 'const.inc'
c      DIMENSION NN(INMTE,*),NMTE(*)
c
c
c
      IF (NAEQ.NE.0) THEN
cccc EQUATION VERSION
c
      INB=0
ccc each element
      DO 10 I=1,NTE
      NIE = NMTE(I)
ccc last node
      K = NIE
c
      NFX=IDIM*NN(K,I)-2
      NFY=IDIM*NN(K,I)-1
      NFZ=IDIM*NN(K,I)
      DO 21 II = 1,NAEQ
      DO 11 KK = 1,NTEQ(II)
      IF ((IDIM*NN(K,I)-2).EQ.NEQ(II,KK)) NFX=NEQB(II)
      IF ((IDIM*NN(K,I)-1).EQ.NEQ(II,KK)) NFY=NEQB(II)
      IF ((IDIM*NN(K,I))  .EQ.NEQ(II,KK)) NFZ=NEQB(II)
 11   CONTINUE
 21   CONTINUE
c
      IF ((NFX.GT.NFY).AND.(NFX.GT.NFZ)) THEN
         IMAX = NFX
         IF ( NFY.GT.NFZ) THEN
            IMIN = NFZ
         ELSE
            IMIN = NFY
         ENDIF
      ELSE
         IF (NFY.GT.NFZ) THEN
            IMAX = NFY
            IF (NFZ.GT.NFX) THEN 
               IMIN = NFX
            ELSE
               IMIN = NFZ
            ENDIF
         ELSE
            IMAX = NFZ
            IF (NFY.GT.NFX) THEN 
               IMIN = NFX
            ELSE
               IMIN = NFY
            ENDIF
         ENDIF
      ENDIF
c        WRITE(6,*)NFX,NFY,NFZ,'-->',IMIN,IMAX
ccc each node
      DO 20 K=1,NIE-1
      NFX=IDIM*NN(K,I)-2
      NFY=IDIM*NN(K,I)-1
      NFZ=IDIM*NN(K,I)
      DO 22 II = 1,NAEQ
      DO 12 KK = 1,NTEQ(II)
      IF ((IDIM*NN(K,I)-2).EQ.NEQ(II,KK)) NFX=NEQB(II)
      IF ((IDIM*NN(K,I)-1).EQ.NEQ(II,KK)) NFY=NEQB(II)
      IF ((IDIM*NN(K,I))  .EQ.NEQ(II,KK)) NFZ=NEQB(II)
 12   CONTINUE
 22   CONTINUE
c
      IF ((NFX.GT.NFY).AND.(NFX.GT.NFZ)) THEN
         IMAX0 = NFX
         IF ( NFY.GT.NFZ) THEN
            IMIN0 = NFZ
         ELSE
            IMIN0 = NFY
         ENDIF
      ELSE
         IF (NFY.GT.NFZ) THEN
            IMAX0 = NFY
            IF (NFZ.GT.NFX) THEN 
               IMIN0 = NFX
            ELSE
               IMIN0 = NFZ
            ENDIF
         ELSE
            IMAX0 = NFZ
            IF (NFY.GT.NFX) THEN 
               IMIN0 = NFX
            ELSE
               IMIN0 = NFY
            ENDIF
         ENDIF
      ENDIF
      IF ( IMIN0.LT.IMIN) IMIN = IMIN0
      IF ( IMAX0.GT.IMAX) IMAX = IMAX0
c        WRITE(6,*)NFX,NFY,NFZ,'-->',IMIN0,IMAX0,IMIN,IMAX
c
 20   CONTINUE
      IDIF=IMAX-IMIN
      IF(IDIF.GT.INB) INB=IDIF
 10   CONTINUE
      NB=INB+1
c
      ELSE
cccc NOT EQUATION VERSION
c
      INB=0
      DO 100 I=1,NTE
      NIE = NMTE(I)
      IMAX=NN(NIE,I)
      IMIN=NN(NIE,I)
      DO 200 J=1,NIE-1
      IF(NN(J,I).GT.IMAX) IMAX=NN(J,I)
      IF(NN(J,I).LT.IMIN) IMIN=NN(J,I)
 200   CONTINUE
      IDIF=IMAX-IMIN
      IF(IDIF.GT.INB) INB=IDIF
 100   CONTINUE
      NB=IDIM*(INB+1)
c
      ENDIF
C+++++++++++++++++++++++++++++++++++++++++
      write(77,*)'BAND HALF WIDTH=',nb
C+++++++++++++++++++++++++++++++++++++++++
      RETURN
      END
