      SUBROUTINE DATA(A,NMTE,ECON,T,NN,X,Y,
     +     IFOR,FB,IDIS,UB,NGNG,NOM,IECON,NEUS,NNUS)
      INCLUDE 'para.inc'
      INCLUDE 'const.inc'
      DIMENSION NMTE(*),NN(INMTE,*),X(*),Y(*),IFOR(*),IDIS(*),FB(*),
     +     UB(*),NOM(*),ECON(9,*),NGNG(*),IECON(*)
c      DIMENSION NEUS(100),NNUS(100)
      DIMENSION NEUS(*),NNUS(*)
      OPEN(1,FILE='input.dat')
C     CHARACTER *1 A(72)
C     READ(5,1)A
C     1 FORMAT(72A1)
C     WRITE(6,1)A
      READ(1,*)NGAUSS
      READ(1,*)NPARA,T,MNUM
C+++++++++++++++++++++++++++++++++++++
      write(77,*)'DATA CHECK'
      if (npara.eq.0) write(77,*)'PLANE STRESS ANALYSIS'
      if (npara.eq.1) write(77,*)'PLANE STRAIN ANALYSIS'
      if (npara.eq.2) write(77,*)'AXIAL SYMMERTY ANALYSIS'
      write(77,*)'THICKNESS =   ',t
      write(77,*)'NUMBER OF MATERIAL =   ',MNUM
      write(77,*)'INTEGRATION ORDER =    ',NGAUSS
C+++++++++++++++++++++++++++++++++++++
C--ANALYSIS CONDITION------------
C NPARA=0 --> PLANE STRESS
C NPARA=1 --> PLANE STRAIN
C NPARA=2 --> AXIAL SYMMETRY
C--------------------------------
C*ELASTIC CONSTANTS 
C  IECON = 1 --> ISOTROPIC
C    ECON(1,L)=YOUNG MODULE , ECON(2,L)=POISSON RATIO
C  IECON = 2 --> ORTHOTROPIC
C    ECON(1,L)=C11 ECON(2,L)=C22 ECON(3,L)=C33 ECON(4,L)=C44
C    ECON(5,L)=C55 ECON(6,L)=C66 ECON(7,L)=C12 ECON(8,L)=C13 
C    ECON(9,L)=C23  12->4 13->5 23->6
      DO 5 L=1,MNUM
	 READ(1,*)IECON(L)
         IEC=IECON(L)
	 IF (IEC.EQ.1)  THEN
          READ(1,*)MN,ECON(1,L),ECON(2,L)
C+++++++++++++++++++++++++++++++++++++
          write(77,*)'Material',L
          write(77,*)'YOUNG=',ECON(1,L),', POISSON=',ECON(2,L)
C+++++++++++++++++++++++++++++++++++++
          ELSE
	 IF (IEC.EQ.2)  THEN
           READ(1,*)MN,ECON(1,L),ECON(2,L),ECON(3,L)
     +                ,ECON(4,L),ECON(5,L),ECON(6,L)
     +                ,ECON(7,L),ECON(8,L),ECON(9,L)
C+++++++++++++++++++++++++++++++++++++
          write(77,*)'Material',L
      write(77,*)'C11=',ECON(1,L),', C22=',ECON(2,L),', C33=',ECON(3,L)
      write(77,*)'C44=',ECON(4,L),', C55=',ECON(5,L),', C66=',ECON(6,L)
      write(77,*)'C12=',ECON(7,L),', C13=',ECON(8,L),', C23=',ECON(9,L)
C+++++++++++++++++++++++++++++++++++++
         ENDIF
         ENDIF
 5    CONTINUE
c
c      DO 5 L=1,MNUM
c         READ(1,*)MN,YO(L),PO(L)
c 5    CONTINUE
c
      READ(1,*)NTN,NTE
c      NTF=NTN*2
      NTF=NTN*IDIM
C+++++++++++++++++++++++++++++++++++++++++
      write(77,*)'TOTAL NODES    =   ',NTN
      write(77,*)'TOTAL ELEMENTS =   ',NTE
      write(77,*)'TOTAL FREEDOMS =   ',NTF
C+++++++++++++++++++++++++++++++++++++++++
      NNA=0
      DO 20 IE=1,NTE
         READ(1,*)II,NOM(IE),NMTE(IE)
c*SORT IE : PROGRAM ELEMENT NUMBER , NEUS(IE) : USER ELEMENT NUMBER
         NEUS(IE)=II
C           READ(1,*)NN(1,IE),NN(2,IE),NN(3,IE),NN(4,IE),
C     +              NN(5,IE),NN(6,IE),NN(7,IE),NN(8,IE)
c---- 6 nodes triangle
         IF(NMTE(IE).EQ.6) THEN
           NGNG(IE)=NGAUSS+1
           READ(1,*)NN(1,IE),NN(2,IE),NN(3,IE),NN(4,IE),
     +              NN(5,IE),NN(6,IE)
C+++++++++++++++++++++++++++++++++++++++++
      write(77,*)'ELEMENT',IE,':  MATERIAL'
     +                         ,NOM(IE),' : 6 NODES TRIANGLE'
C+++++++++++++++++++++++++++++++++++++++++
c---- 8 nodes rectangle(quadrangle)
         ELSE IF(NMTE(IE).EQ.8) THEN
           READ(1,*)NN(1,IE),NN(2,IE),NN(3,IE),NN(4,IE),
     +              NN(5,IE),NN(6,IE),NN(7,IE),NN(8,IE) 
           NGNG(IE)=NGAUSS*NGAUSS
C+++++++++++++++++++++++++++++++++++++++++
      write(77,*)'ELEMENT',IE,':  MATERIAL',NOM(IE)
     +                           ,' : 8 NODES RECTANGLE'
C+++++++++++++++++++++++++++++++++++++++++
c---- 4 nodes rectangle
         ELSE IF(NMTE(IE).EQ.4) THEN
           READ(1,*)NN(1,IE),NN(2,IE),NN(3,IE),NN(4,IE)
           NGNG(IE)=NGAUSS*NGAUSS
C+++++++++++++++++++++++++++++++++++++++++
      write(77,*)'ELEMENT',IE,':  MATERIAL',NOM(IE)
     +                           ,' : 4 NODES RECTANGLE'
C+++++++++++++++++++++++++++++++++++++++++
         ENDIF
         NNA=NNA+NGNG(IE)
 20   CONTINUE
C+++++++++++++++++++++++++++++++++++++++++
        write(77,*)'TOTAL INT.POINTS =   ',NNA
        write(77,*)'COORDINATE OF NODES'
        write(77,*)'PRO.NUM. , USR NUM. ,COORDINATION OF NODES'
C+++++++++++++++++++++++++++++++++++++++++
      DO 40 I=1,NTN
         READ(1,*)JJ,X(I),Y(I)
        write(77,112)I,JJ,X(I),Y(I)
C*SORT I : PROGRAM NODE NUMBER , NNUS(I) : USER NODE NUMBER
         NNUS(I)=JJ
 40   CONTINUE
C+++++++++++++++++++++++++++++++++++++++++
 112  format(2(I4,x),2e15.7)
c      
      WRITE(77,*)'*ELEMENT NODE IS RECONSTRUCTED'
c
      DO 200 IE=1,NTE
        NMIE=NMTE(IE)
        WRITE(77,*)'USER   ',(NN(J3,IE),J3=1,NMIE)
c
       DO 210 J2 = 1,NMIE
        NNJ2 = NN(J2,IE)
        DO 220 I2 = 1,NTN
           KK = NNUS(I2)
           IF ( KK.EQ.NNJ2 ) THEN
            NN(J2,IE) = I2
           GO TO 210
           ENDIF
 220    CONTINUE
          WRITE(6,*)'NO MATCH'
          STOP
 210    CONTINUE
        WRITE(77,*)'PROGRAM',(NN(J3,IE),J3=1,NMIE)
c
c----- old  part ----------------------
c       DO 210 I2 = 1,NTN
cC I : PROGRAM NODE NUMBER , NNUS(I) : USER NODE NUMBER
c         KK=NNUS(I2)
c        DO 220 J2 = 1,NMIE
cc USER NODE NUMBER --> PROGRAM NODE NUMBER
c        IF ( KK.EQ.NN(J2,IE) ) THEN
c           NN(J2,IE)=I2
c           write(6,*)'FIND',I2,J2
c           GO TO 210
c        ENDIF
c 220    CONTINUE
c           write(6,*)'NOT FIND',I2,J2
c 210   CONTINUE
c        WRITE(99,*)'PROGRAM',(NN(J3,IE),J3=1,NMIE)
 200  CONTINUE
c----- old  part ----------------------
c
      WRITE(77,*)'*FORCE BOUNDARY'
c
      READ(1,*)NTFOR
      IF(NTFOR.LT.1) GO TO 51
      DO 50 I=1,NTFOR
         READ(1,*)IFO,IXY,FF
c  IFO(USER NODE NUMBER) --> IFOP(PROGRAM NODE NUMBER)
         DO 55 I2 = 1,NTN
           KK=NNUS(I2)            
         IF ( KK.EQ.IFO ) THEN
           IFOP=I2
           GO TO 56
         ENDIF
 55      CONTINUE
            WRITE(77,*)'INVALID BOUNDARY CONDITION!(NO NODE)'
            WRITE(6,*)'ERROR!!'
            STOP
 56      CONTINUE
c         WRITE(6,*)IFO,IFOP
c------------------------------------------
         IF (IXY.GT.IDIM) THEN
            WRITE(77,*)'INVALID BOUNDARY CONDITION!(IXY.GT.IDIM)'
            WRITE(6,*)'ERROR'
            GO TO 51
         ENDIF
         NFREE = (IFOP-1)*IDIM + IXY
          IFOR(I)=NFREE
          FB(I) = FF
          IF (IXY.EQ.1) WRITE(77,*)'NODE',IFO,'-->FX=',FB(I),NFREE
          IF (IXY.EQ.2) WRITE(77,*)'NODE',IFO,'-->FY=',FB(I),NFREE
c
 50   CONTINUE
 51   CONTINUE
c
      WRITE(77,*)'*DISPLACEMENT BOUNDARY'
      READ(1,*)NTDIS
      IF(NTDIS.LT.1) GO TO 61
      DO 60 I=1,NTDIS
         READ(1,*)IDI,IXY,UU
c  IDI(USER NODE NUMBER) --> IDIP(PROGRAM NODE NUMBER)
         DO 65 I2 = 1,NTN
           KK=NNUS(I2)            
         IF ( KK.EQ.IDI ) THEN
           IDIP=I2
           GO TO 66
         ENDIF
 65      CONTINUE
            WRITE(77,*)'INVALID BOUNDARY CONDITION!(NO NODE)'
            WRITE(6,*)'ERROR!!'
            STOP
 66      CONTINUE
c         WRITE(6,*)IDI,IDIP
c------------------------------------------
         IF (IXY.GT.IDIM) THEN
            WRITE(77,*)'INVALID BOUNDARY CONDITION!(IXY.GT.IDIM)'
            WRITE(6,*)'ERROR'
            GO TO 61
         ENDIF
         NFREE = (IDIP-1)*IDIM + IXY
          IDIS(I)=NFREE
          UB(I) = UU
          IF (IXY.EQ.1) WRITE(77,*)'NODE',IDI,'-->UX=',UB(I),NFREE
          IF (IXY.EQ.2) WRITE(77,*)'NODE',IDI,'-->UY=',UB(I),NFREE
 60   CONTINUE
 61   CONTINUE
      CLOSE(1)
c      
      RETURN
      END
