C     GAUSS-LEGENDRE PROGRAM
c      SUBROUTINE GAUSS(AXI,AETA,AZETA,H,NMTE)
      SUBROUTINE GAUSS
      use fem_arrays
      implicit integer (i-n)
      implicit double precision (a-h,o-z)
c      INCLUDE 'para.inc'
c      INCLUDE 'const.inc'
c      DIMENSION AXI(*),AETA(*),AZETA(*),H(*),NMTE(*)
C  6MENTAI-8NODE NO SEKIBUN
C  2ND-ORDER , INTEGRATION 
      IF((NMTE(IE).EQ.8).AND.(NGAUSS.EQ.2))THEN
C
      A_1=0.57735026918926
cccc  A_1=1.0/3.0**0.5
      DO 50 I=1,8
      H(I)=1.0
  50  CONTINUE
C   
      AXI(1)  =-A_1
      AETA(1) =-A_1
      AZETA(1)=-A_1
      AXI(2)  = A_1
      AETA(2) =-A_1
      AZETA(2)=-A_1
      AXI(3)  =-A_1
      AETA(3) = A_1
      AZETA(3)=-A_1
      AXI(4)  = A_1
      AETA(4) = A_1
      AZETA(4)=-A_1
C
      DO 111 I8 = 1,4
       AXI(4+I8)  =  AXI(I8)
       AETA(4+I8) =  AETA(I8)
       AZETA(4+I8)= -AZETA(I8)
 111  CONTINUE
C
C  6MENTAI-20NODE NO SEKIBUN
C  3RD-ORDER , INTEGRATION 
      ELSE IF((NMTE(IE).EQ.20).AND.(NGAUSS.EQ.2))THEN
C
      A_1=0.57735026918926
cccc  A_1=1.0/3.0**0.5
      DO 55 I=1,8
      H(I)=1.0
 55   CONTINUE
C   
      AXI(1)  =-A_1
      AETA(1) =-A_1
      AZETA(1)=-A_1
      AXI(2)  = A_1
      AETA(2) =-A_1
      AZETA(2)=-A_1
      AXI(3)  =-A_1
      AETA(3) = A_1
      AZETA(3)=-A_1
      AXI(4)  = A_1
      AETA(4) = A_1
      AZETA(4)=-A_1
C
      DO 116 I8 = 1,4
       AXI(4+I8)  =  AXI(I8)
       AETA(4+I8) =  AETA(I8)
       AZETA(4+I8)= -AZETA(I8)
 116  CONTINUE
C
C  6MENTAI-20NODE NO SEKIBUN
C  3RD-ORDER , INTEGRATION 
      ELSE IF((NMTE(IE).EQ.8).AND.(NGAUSS.EQ.3))THEN
C
      HB1 = 5.0 / 9.0
      HB0 = 8.0 / 9.0
C
      B_1 = 0.774596669241483
      B_0 = 0.000000000000000
      AXI(1)  = - B_1 
      AETA(1) = - B_1
      AZETA(1)= - B_1
      H(1)= HB1 * HB1 * HB1
      AXI(2)  =   B_0 
      AETA(2) = - B_1
      AZETA(2)= - B_1
      H(2)= HB0 * HB1 * HB1
      AXI(3)  =   B_1 
      AETA(3) = - B_1
      AZETA(3)= - B_1
      H(3)= HB1 * HB1 * HB1
c
      AXI(4)  = - B_1 
      AETA(4) =   B_0
      AZETA(4)= - B_1
      H(4)= HB1 * HB0 * HB1
      AXI(5)  =   B_0 
      AETA(5) =   B_0
      AZETA(5)= - B_1
      H(5)= HB0 * HB0 * HB1
      AXI(6)  =   B_1 
      AETA(6) =   B_0
      AZETA(6)= - B_1
      H(6)= HB1 * HB0 * HB1
c
      AXI(7)  = - B_1 
      AETA(7) =   B_1
      AZETA(7)= - B_1
      H(7)= HB1 * HB1 * HB1
      AXI(8)  =   B_0
      AETA(8) =   B_1
      AZETA(8)= - B_1
      H(8)= HB0 * HB1 * HB1
      AXI(9)  =   B_1 
      AETA(9) =   B_1
      AZETA(9)= - B_1
      H(9)= HB1 * HB1 * HB1
c
      DO 224 I=1,9
       AXI(9+I)  = AXI(I) 
       AETA(9+I) = AETA(I)
       AZETA(9+I)= B_0
       H(9+I)= H(I)/HB1*HB0
 224  CONTINUE
C
      DO 334 I=1,9
       AXI(18+I)  = AXI(I) 
       AETA(18+I) = AETA(I)
       AZETA(18+I)= B_1
       H(18+I)= H(I)
 334  CONTINUE
C
C  6MENTAI-20NODE NO SEKIBUN
C  3RD-ORDER , INTEGRATION 
      ELSE IF((NMTE(IE).EQ.20).AND.(NGAUSS.EQ.3))THEN
C
      HB1 = 5.0 / 9.0
      HB0 = 8.0 / 9.0
C
      B_1 = 0.774596669241483
      B_0 = 0.000000000000000
      AXI(1)  = - B_1 
      AETA(1) = - B_1
      AZETA(1)= - B_1
      H(1)= HB1 * HB1 * HB1
      AXI(2)  =   B_0 
      AETA(2) = - B_1
      AZETA(2)= - B_1
      H(2)= HB0 * HB1 * HB1
      AXI(3)  =   B_1 
      AETA(3) = - B_1
      AZETA(3)= - B_1
      H(3)= HB1 * HB1 * HB1
c
      AXI(4)  = - B_1 
      AETA(4) =   B_0
      AZETA(4)= - B_1
      H(4)= HB1 * HB0 * HB1
      AXI(5)  =   B_0 
      AETA(5) =   B_0
      AZETA(5)= - B_1
      H(5)= HB0 * HB0 * HB1
      AXI(6)  =   B_1 
      AETA(6) =   B_0
      AZETA(6)= - B_1
      H(6)= HB1 * HB0 * HB1
c
      AXI(7)  = - B_1 
      AETA(7) =   B_1
      AZETA(7)= - B_1
      H(7)= HB1 * HB1 * HB1
      AXI(8)  =   B_0
      AETA(8) =   B_1
      AZETA(8)= - B_1
      H(8)= HB0 * HB1 * HB1
      AXI(9)  =   B_1 
      AETA(9) =   B_1
      AZETA(9)= - B_1
      H(9)= HB1 * HB1 * HB1
c
      DO 222 I=1,9
       AXI(9+I)  = AXI(I) 
       AETA(9+I) = AETA(I)
       AZETA(9+I)= B_0
       H(9+I)= H(I)/HB1*HB0
 222  CONTINUE
C
      DO 333 I=1,9
       AXI(18+I)  = AXI(I) 
       AETA(18+I) = AETA(I)
       AZETA(18+I)= B_1
       H(18+I)= H(I)
 333  CONTINUE
C
C  5MENTAI-6NODE NO SEKIBUN
C  1st-ORDER , INTEGRATION 
      ELSE IF((NMTE(IE).EQ.6).AND.(NGAUSS.EQ.1))THEN
ccc research
      C1=1.0/3.0
      C2=0.57735026918926
      HC1 = 0.5
      HC2 = 1.0
C      
      DO 60 I=1,2
      H(I)=HC1 * HC2
  60  CONTINUE
      AXI(1)=C1
      AETA(1)=C1
      AZETA(1)=-C2
      AXI(2)=C1
      AETA(2)=C1
      AZETA(2)=C2
C
C  5MENTAI-15NODE NO SEKIBUN
c  2ND-ORDER , INTEGRATION 
      ELSE IF((NMTE(IE).EQ.15).AND.(NGAUSS.EQ.2))THEN
ccc reserch
      D1=1.0/6.0
      D2=2.0/3.0
      D3=0.57735026918926
      HD1=1.0/6.0
      HD2=1.0
      DO 70 I=1,6
      H(I)= HD1 * HD2
  70  CONTINUE
      AXI(1)  = D1
      AETA(1) = D1
      AZETA(1)= -D3
      AXI(2)  = D2
      AETA(2) = D1
      AZETA(2)= -D3
      AXI(3)  = D1
      AETA(3) = D2
      AZETA(3)= -D3
c
      AXI(4)  = D1
      AETA(4) = D1
      AZETA(4)= D3
      AXI(5)  = D2
      AETA(5) = D1
      AZETA(5)= D3
      AXI(6)  = D1
      AETA(6) = D2
      AZETA(6)= D3
c
C  5MENTAI-15NODE NO SEKIBUN
c  3RD-ORDER , INTEGRATION 
      ELSE IF((NMTE(IE).EQ.15).AND.(NGAUSS.EQ.3))THEN
C
      E1=1.0/3.0
      E2=1.0/5.0
      E3=3.0/5.0
      E4=0.774596669241483
C
      HE1=-27.0/96.0
      HE2= 25.0/96.0
      HE3=  8.0/9.0
      HE4=  5.0/9.0
c
      AXI(1)  = E1
      AETA(1) = E1
      AZETA(1)= -E4
      H(1)= HE1 * HE4
      AXI(2)  = E2
      AETA(2) = E2
      AZETA(2)= -E4
      H(2)= HE2 * HE4
      AXI(3)  = E3
      AETA(3) = E2
      AZETA(3)= -E4
      H(3)= HE2 * HE4
      AXI(4)  = E2
      AETA(4) = E3      
      AZETA(4)= -E4
      H(4)= HE2 * HE4
C
      AXI(5)  = E1
      AETA(5) = E1
      AZETA(5)= 0.0
      H(5)= HE1 * HE3
      AXI(6)  = E2
      AETA(6) = E2
      AZETA(6)= 0.0
      H(6)= HE2 * HE3
      AXI(7)  = E3
      AETA(7) = E2
      AZETA(7)= 0.0
      H(7)= HE2 * HE3
      AXI(8)  = E2
      AETA(8) = E3      
      AZETA(8)= 0.0
      H(8)= HE2 * HE3
C
      AXI(9)  = E1
      AETA(9) = E1
      AZETA(9)= E4
      H(9)= HE1 * HE4
      AXI(10)  = E2
      AETA(10) = E2
      AZETA(10)= E4
      H(10)= HE2 * HE4
      AXI(11)  = E3
      AETA(11) = E2
      AZETA(11)= E4
      H(11)= HE2 * HE4
      AXI(12)  = E2
      AETA(12) = E3      
      AZETA(12)= E4
      H(12)= HE2 * HE4
C
      END IF
c
      RETURN
      END
