c      SUBROUTINE INT(XI,ETA,ZETA,N,DNDXI,DNDETA,DNDZETA,
c     +               NIF,DXIF,DETIF,DZEIF,NMTE,NN,NKIND)
      SUBROUTINE INT
      use fem_arrays
      implicit integer (i-n)
      implicit double precision (a-h,o-z)
c      
      NIE = NMTE(IE)
      NKK = NKINF(IE)
c
ccc sankaku-tyuu(liner element 6nodes)
      IF(NIE.EQ.6) THEN
      RD = 1.0 - XXI - ETA
      A0 = (1.0-ZETA)/2.0
      B0 = (1.0+ZETA)/2.0
c <N>     
      SHN(1)= RD  * A0
      SHN(2)= XXI  * A0
      SHN(3)= ETA * A0 
      SHN(4)= RD  * B0
      SHN(5)= XXI  * B0
      SHN(6)= ETA * B0
c <dN/dXI>     
      DNDXI(1)= -A0
      DNDXI(2)=  A0
      DNDXI(3)=  0.0 
      DNDXI(4)= -B0
      DNDXI(5)=  B0 
      DNDXI(6)=  0.0
c <dN/dETA>     
      DNDETA(1)= -A0 
      DNDETA(2)= 0.0
      DNDETA(3)=  A0 
      DNDETA(4)= -B0
      DNDETA(5)= 0.0
      DNDETA(6)=  B0
c <dN/dZETA>     
      DNDZETA(1)= -RD / 2.0
      DNDZETA(2)= -XXI / 2.0
      DNDZETA(3)= -ETA/ 2.0
      DNDZETA(4)=  RD / 2.0 
      DNDZETA(5)=  XXI / 2.0
      DNDZETA(6)=  ETA/ 2.0
C
      ELSE
ccc 6-mentai(liner element 8nodes)
      IF(NIE.EQ.8) THEN
      A1 = 1.0 + XXI
      B1 = 1.0 + ETA
      C1 = 1.0 + ZETA
      A2 = 1.0 - XXI
      B2 = 1.0 - ETA
      C2 = 1.0 - ZETA
      DD_D = 1.0/8.0
c <N>     
      SHN(1)= A2 * B2 * C2 * DD_D
      SHN(2)= A1 * B2 * C2 * DD_D
      SHN(3)= A1 * B1 * C2 * DD_D
      SHN(4)= A2 * B1 * C2 * DD_D
      SHN(5)= A2 * B2 * C1 * DD_D
      SHN(6)= A1 * B2 * C1 * DD_D
      SHN(7)= A1 * B1 * C1 * DD_D
      SHN(8)= A2 * B1 * C1 * DD_D
c <dN/dXI>     
      DNDXI(1)= -B2 * C2 * DD_D 
      DNDXI(2)=  B2 * C2 * DD_D
      DNDXI(3)=  B1 * C2 * DD_D
      DNDXI(4)= -B1 * C2 * DD_D
      DNDXI(5)= -B2 * C1 * DD_D
      DNDXI(6)=  B2 * C1 * DD_D
      DNDXI(7)=  B1 * C1 * DD_D
      DNDXI(8)= -B1 * C1 * DD_D
c <dN/dETA>
      DNDETA(1)= -A2 * C2 * DD_D
      DNDETA(2)= -A1 * C2 * DD_D
      DNDETA(3)=  A1 * C2 * DD_D
      DNDETA(4)=  A2 * C2 * DD_D
      DNDETA(5)= -A2 * C1 * DD_D
      DNDETA(6)= -A1 * C1 * DD_D
      DNDETA(7)=  A1 * C1 * DD_D
      DNDETA(8)=  A2 * C1 * DD_D
c <dN/dZETA>
      DNDZETA(1)= -A2 * B2 * DD_D
      DNDZETA(2)= -A1 * B2 * DD_D
      DNDZETA(3)= -A1 * B1 * DD_D
      DNDZETA(4)= -A2 * B1 * DD_D
      DNDZETA(5)=  A2 * B2 * DD_D
      DNDZETA(6)=  A1 * B2 * DD_D
      DNDZETA(7)=  A1 * B1 * DD_D
      DNDZETA(8)=  A2 * B1 * DD_D
c
ccc 6-mentai(liner element 8nodes)--> infinite element
      IF(NKK.EQ.1) THEN
c     
      AI1 = 1.0 + XXI
      BI1 = 1.0 + ETA
      AI2 = 1.0 - XXI
      BI2 = 1.0 - ETA
      DDI  = 1.0/4.0
      XINV = 1.0/(1.0-ZETA)
c
      CI1  =   1.0 + 2.0  * ZETA   *XINV
      CI2  = - 2.0 * ZETA   * XINV
      DCI1 =   2.0 * XINV * XINV
      DCI2 = - 2.0 * XINV * XINV
c
c <N>     
      SHNIF(1)= AI2 * BI2 * CI2 * DDI
      SHNIF(2)= AI1 * BI2 * CI2 * DDI
      SHNIF(3)= AI1 * BI1 * CI2 * DDI
      SHNIF(4)= AI2 * BI1 * CI2 * DDI
      SHNIF(5)= AI2 * BI2 * CI1 * DDI
      SHNIF(6)= AI1 * BI2 * CI1 * DDI
      SHNIF(7)= AI1 * BI1 * CI1 * DDI
      SHNIF(8)= AI2 * BI1 * CI1 * DDI
c <dN/dXI>     
      DXIF(1)= - BI2 * CI2 * DDI
      DXIF(2)=   BI2 * CI2 * DDI
      DXIF(3)=   BI1 * CI2 * DDI
      DXIF(4)= - BI1 * CI2 * DDI
      DXIF(5)= - BI2 * CI1 * DDI
      DXIF(6)=   BI2 * CI1 * DDI
      DXIF(7)=   BI1 * CI1 * DDI
      DXIF(8)= - BI1 * CI1 * DDI
c <dN/dETA>
      DETIF(1)= -AI2 * CI2 * DDI
      DETIF(2)= -AI1 * CI2 * DDI
      DETIF(3)=  AI1 * CI2 * DDI
      DETIF(4)=  AI2 * CI2 * DDI
      DETIF(5)= -AI2 * CI1 * DDI
      DETIF(6)= -AI1 * CI1 * DDI
      DETIF(7)=  AI1 * CI1 * DDI
      DETIF(8)=  AI2 * CI1 * DDI
c <dN/dZETA>
      DZEIF(1)=  AI2 * BI2 * DCI2 * DDI
      DZEIF(2)=  AI1 * BI2 * DCI2 * DDI
      DZEIF(3)=  AI1 * BI1 * DCI2 * DDI
      DZEIF(4)=  AI2 * BI1 * DCI2 * DDI
      DZEIF(5)=  AI2 * BI2 * DCI1 * DDI
      DZEIF(6)=  AI1 * BI2 * DCI1 * DDI
      DZEIF(7)=  AI1 * BI1 * DCI1 * DDI
      DZEIF(8)=  AI2 * BI1 * DCI1 * DDI
c      write(661,6677)IE,DXIF(1),DXIF(2),DXIF(3),DXIF(4)
c     &,DXIF(5),DXIF(6),DXIF(7),DXIF(8)
c      write(662,6677)IE,DETIF(1),DETIF(2),DETIF(3),DETIF(4)
c     &,DETIF(5),DETIF(6),DETIF(7),DETIF(8)
c      write(663,6677)IE,DZEIF(1),DZEIF(2),DZEIF(3),DZEIF(4)
c     &,DZEIF(5),DZEIF(6),DZEIF(7),DZEIF(8)
c 6677 format(i5,8e12.4)
c
      ENDIF
      ELSE
c
      IF(NIE.EQ.20) THEN
c <SHN> 
cccc corner cord.
c  SHN(*) =(1.0?XI)*(1.0??ETA)*(1.0???ZETA)*(-2.0?XI??ETA???ZETA)/8.0
c
      SHN(1) =(1.0-XXI)*(1.0-ETA)*(1.0-ZETA)*(-2.0-XXI-ETA-ZETA)/8.0
      SHN(2) =(1.0+XXI)*(1.0-ETA)*(1.0-ZETA)*(-2.0+XXI-ETA-ZETA)/8.0
      SHN(3) =(1.0+XXI)*(1.0+ETA)*(1.0-ZETA)*(-2.0+XXI+ETA-ZETA)/8.0
      SHN(4) =(1.0-XXI)*(1.0+ETA)*(1.0-ZETA)*(-2.0-XXI+ETA-ZETA)/8.0
      SHN(5) =(1.0-XXI)*(1.0-ETA)*(1.0+ZETA)*(-2.0-XXI-ETA+ZETA)/8.0
      SHN(6) =(1.0+XXI)*(1.0-ETA)*(1.0+ZETA)*(-2.0+XXI-ETA+ZETA)/8.0
      SHN(7) =(1.0+XXI)*(1.0+ETA)*(1.0+ZETA)*(-2.0+XXI+ETA+ZETA)/8.0
      SHN(8) =(1.0-XXI)*(1.0+ETA)*(1.0+ZETA)*(-2.0-XXI+ETA+ZETA)/8.0
cccc  middle-point XXI
c  SHN(*) =(1.0-XXI*XXI)(1.0?ETA)(1.0??ZETA)/4.0
      SHN(9) =(1.0-XXI*XXI)*(1.0-ETA)*(1.0-ZETA)/4.0
      SHN(11) =(1.0-XXI*XXI)*(1.0+ETA)*(1.0-ZETA)/4.0
      SHN(13)=(1.0-XXI*XXI)*(1.0-ETA)*(1.0+ZETA)/4.0
      SHN(15)=(1.0-XXI*XXI)*(1.0+ETA)*(1.0+ZETA)/4.0
cccc  middle-point ETA
c  SHN(*) =(1.0?XXI)(1.0-ETA*ETA)(1.0??ZETA)/4.0
      SHN(10) =(1.0+XXI)*(1.0-ETA*ETA)*(1.0-ZETA)/4.0
      SHN(12) =(1.0-XXI)*(1.0-ETA*ETA)*(1.0-ZETA)/4.0
      SHN(14)=(1.0+XXI)*(1.0-ETA*ETA)*(1.0+ZETA)/4.0
      SHN(16)=(1.0-XXI)*(1.0-ETA*ETA)*(1.0+ZETA)/4.0
cccc  middle-point ZETA
c  SHN(*) =(1.0?XXI)(1.0??ETA)(1.0-ZETA*ZETA)/4.0
      SHN(17)=(1.0-XXI)*(1.0-ETA)*(1.0-ZETA*ZETA)/4.0
      SHN(18)=(1.0+XXI)*(1.0-ETA)*(1.0-ZETA*ZETA)/4.0
      SHN(19)=(1.0+XXI)*(1.0+ETA)*(1.0-ZETA*ZETA)/4.0
      SHN(20)=(1.0-XXI)*(1.0+ETA)*(1.0-ZETA*ZETA)/4.0
c
c <dN/dXI>     
cccc corner cord.
c  DNDXI(*) = ?(1.0??ETA)*(1.0???ZETA)*(-1.0?2.0*XXI??ETA???ZETA)/8.0
      DNDXI(1) = -(1.0-ETA)*(1.0-ZETA)*(-1.0-2.0*XXI-ETA-ZETA)/8.0
      DNDXI(2) =  (1.0-ETA)*(1.0-ZETA)*(-1.0+2.0*XXI-ETA-ZETA)/8.0
      DNDXI(3) =  (1.0+ETA)*(1.0-ZETA)*(-1.0+2.0*XXI+ETA-ZETA)/8.0
      DNDXI(4) = -(1.0+ETA)*(1.0-ZETA)*(-1.0-2.0*XXI+ETA-ZETA)/8.0
      DNDXI(5) = -(1.0-ETA)*(1.0+ZETA)*(-1.0-2.0*XXI-ETA+ZETA)/8.0
      DNDXI(6) =  (1.0-ETA)*(1.0+ZETA)*(-1.0+2.0*XXI-ETA+ZETA)/8.0
      DNDXI(7) =  (1.0+ETA)*(1.0+ZETA)*(-1.0+2.0*XXI+ETA+ZETA)/8.0
      DNDXI(8) = -(1.0+ETA)*(1.0+ZETA)*(-1.0-2.0*XXI+ETA+ZETA)/8.0
cccc  middle-point XXI
c  DNDXI(*) = -XXI(1.0?ETA)(1.0??ZETA)/2.0
      DNDXI(9) =-XXI*(1.0-ETA)*(1.0-ZETA)/2.0
      DNDXI(11)=-XXI*(1.0+ETA)*(1.0-ZETA)/2.0
      DNDXI(13)=-XXI*(1.0-ETA)*(1.0+ZETA)/2.0
      DNDXI(15)=-XXI*(1.0+ETA)*(1.0+ZETA)/2.0
cccc  middle-point ETA
c  DNDXI(*) =?XXI(1.0-ETA*ETA)(1.0??ZETA)/4.0
      DNDXI(10)= (1.0-ETA*ETA)*(1.0-ZETA)/4.0
      DNDXI(12)=-(1.0-ETA*ETA)*(1.0-ZETA)/4.0
      DNDXI(14)= (1.0-ETA*ETA)*(1.0+ZETA)/4.0
      DNDXI(16)=-(1.0-ETA*ETA)*(1.0+ZETA)/4.0
cccc  middle-point ZETA
c  DNDXI(*) =?XXI(1.0??ETA)(1.0-ZETA*ZETA)/4.0
      DNDXI(17) =-(1.0-ETA)*(1.0-ZETA*ZETA)/4.0
      DNDXI(18)= (1.0-ETA)*(1.0-ZETA*ZETA)/4.0
      DNDXI(19)= (1.0+ETA)*(1.0-ZETA*ZETA)/4.0
      DNDXI(20)=-(1.0+ETA)*(1.0-ZETA*ZETA)/4.0
c 
c <dN/dETA>    
cccc corner cord.
      DNDETA(1) = -(1.0-XXI)*(1.0-ZETA)*(-1.0-XXI-2.0*ETA-ZETA)/8.0
      DNDETA(2) = -(1.0+XXI)*(1.0-ZETA)*(-1.0+XXI-2.0*ETA-ZETA)/8.0
      DNDETA(3) =  (1.0+XXI)*(1.0-ZETA)*(-1.0+XXI+2.0*ETA-ZETA)/8.0
      DNDETA(4) =  (1.0-XXI)*(1.0-ZETA)*(-1.0-XXI+2.0*ETA-ZETA)/8.0
      DNDETA(5) = -(1.0-XXI)*(1.0+ZETA)*(-1.0-XXI-2.0*ETA+ZETA)/8.0
      DNDETA(6) = -(1.0+XXI)*(1.0+ZETA)*(-1.0+XXI-2.0*ETA+ZETA)/8.0
      DNDETA(7) =  (1.0+XXI)*(1.0+ZETA)*(-1.0+XXI+2.0*ETA+ZETA)/8.0
      DNDETA(8) =  (1.0-XXI)*(1.0+ZETA)*(-1.0-XXI+2.0*ETA+ZETA)/8.0
cccc  middle-point XXI
c  DNDETA(*) =-?ETA(1.0-XXI*XXI)(1.0??ZETA)/4.0
      DNDETA(9) =-(1.0-XXI*XXI)*(1.0-ZETA)/4.0
      DNDETA(11)= (1.0-XXI*XXI)*(1.0-ZETA)/4.0
      DNDETA(13)=-(1.0-XXI*XXI)*(1.0+ZETA)/4.0
      DNDETA(15)= (1.0-XXI*XXI)*(1.0+ZETA)/4.0
cccc  middle-point ETA
c  DNDETA(*) =-ETA(1.0?XXI)(1.0??ZETA)/2.0
      DNDETA(10) =-ETA*(1.0+XXI)*(1.0-ZETA)/2.0
      DNDETA(12) =-ETA*(1.0-XXI)*(1.0-ZETA)/2.0
      DNDETA(14)=-ETA*(1.0+XXI)*(1.0+ZETA)/2.0
      DNDETA(16)=-ETA*(1.0-XXI)*(1.0+ZETA)/2.0
cccc  middle-point ZETA
c  DNDETA(*) =??ETA(1.0?XXI)(1.0-ZETA*ZETA)/4.0
      DNDETA(17) =-(1.0-XXI)*(1.0-ZETA*ZETA)/4.0
      DNDETA(18)=-(1.0+XXI)*(1.0-ZETA*ZETA)/4.0
      DNDETA(19)= (1.0+XXI)*(1.0-ZETA*ZETA)/4.0
      DNDETA(20)= (1.0-XXI)*(1.0-ZETA*ZETA)/4.0
c
c <dN/dZETA>     
cccc corner cord.
      DNDZETA(1) = -(1.0-XXI)*(1.0-ETA)*(-1.0-XXI-ETA-2.0*ZETA)/8.0
      DNDZETA(2) = -(1.0+XXI)*(1.0-ETA)*(-1.0+XXI-ETA-2.0*ZETA)/8.0
      DNDZETA(3) = -(1.0+XXI)*(1.0+ETA)*(-1.0+XXI+ETA-2.0*ZETA)/8.0
      DNDZETA(4) = -(1.0-XXI)*(1.0+ETA)*(-1.0-XXI+ETA-2.0*ZETA)/8.0
      DNDZETA(5) = +(1.0-XXI)*(1.0-ETA)*(-1.0-XXI-ETA+2.0*ZETA)/8.0
      DNDZETA(6) = +(1.0+XXI)*(1.0-ETA)*(-1.0+XXI-ETA+2.0*ZETA)/8.0
      DNDZETA(7) = +(1.0+XXI)*(1.0+ETA)*(-1.0+XXI+ETA+2.0*ZETA)/8.0
      DNDZETA(8) = +(1.0-XXI)*(1.0+ETA)*(-1.0-XXI+ETA+2.0*ZETA)/8.0
cccc  middle-point XXI
c  DNDZETA(*) =-?ZETA(1.0-XXI*XXI)(1.0??ETA)/4.0
      DNDZETA(9) =-(1.0-XXI*XXI)*(1.0-ETA)/4.0
      DNDZETA(11)=-(1.0-XXI*XXI)*(1.0+ETA)/4.0
      DNDZETA(13)=+(1.0-XXI*XXI)*(1.0-ETA)/4.0
      DNDZETA(15)=+(1.0-XXI*XXI)*(1.0+ETA)/4.0
cccc  middle-point ETA
c  DNDZETA(*) =?ZETA(1.0??XXI)(1.0-ETA*ETA)/4.0
      DNDZETA(10) =-(1.0+XXI)*(1.0-ETA*ETA)/4.0
      DNDZETA(12) =-(1.0-XXI)*(1.0-ETA*ETA)/4.0
      DNDZETA(14)= (1.0+XXI)*(1.0-ETA*ETA)/4.0
      DNDZETA(16)= (1.0-XXI)*(1.0-ETA*ETA)/4.0
cccc  middle-point ZETA
c  DNDZETA(*) =-ZETA(1.0?XXI)(1.0??ETA)/2.0
      DNDZETA(17) =-ZETA*(1.0-XXI)*(1.0-ETA)/2.0
      DNDZETA(18)=-ZETA*(1.0+XXI)*(1.0-ETA)/2.0
      DNDZETA(19)=-ZETA*(1.0+XXI)*(1.0+ETA)/2.0
      DNDZETA(20)=-ZETA*(1.0-XXI)*(1.0+ETA)/2.0
c
      ELSE
C
      IF(NIE.EQ.15) THEN
      RM  = 1.0 - XXI - ETA
      RZ1 = -ZETA*(1.0-ZETA)/2.0
      RZ2 =  ZETA*(1.0+ZETA)/2.0
c <N> 
cccc 
      SHN(1) = -RM*(1.0-2.0*RM)*RZ1
      SHN(7) = 4.0*XXI*RM*RZ1
      SHN(2) = -XXI*(1.0-2.0*XXI)*RZ1
      SHN(8) = 4.0*XXI*ETA*RZ1
      SHN(3) = -ETA*(1.0-2.0*ETA)*RZ1
      SHN(9) = 4.0*ETA*RM*RZ1
      SHN(13)= RM*(1.0-ZETA*ZETA)
      SHN(14)= XXI*(1.0-ZETA*ZETA)
      SHN(15)= ETA*(1.0-ZETA*ZETA)
      SHN(4) = -RM*(1.0-2.0*RM)*RZ2
      SHN(10)= 4.0*XXI*RM*RZ2
      SHN(5) = -XXI*(1.0-2.0*XXI)*RZ2
      SHN(11)= 4.0*XXI*ETA*RZ2
      SHN(6) = -ETA*(1.0-2.0*ETA)*RZ2
      SHN(12)= 4.0*ETA*RM*RZ2
c
c <dN/dXXI>     
      DNDXI(1) = ( 1.0-4.0*RM)*RZ1
      DNDXI(7) =  4.0*(RM-XXI)*RZ1
      DNDXI(2) = (-1.0+4.0*XXI)*RZ1
      DNDXI(8) =  4.0*ETA*RZ1
      DNDXI(3) =  0.0
      DNDXI(9) = -4.0*ETA*RZ1
      DNDXI(13)= -(1.0-ZETA*ZETA)
      DNDXI(14)= ( 1.0-ZETA*ZETA)
      DNDXI(15)=  0.0
      DNDXI(4) = ( 1.0-4.0*RM)*RZ2
      DNDXI(10)=  4.0*(RM-XXI)*RZ2
      DNDXI(5) = (-1.0+4.0*XXI)*RZ2
      DNDXI(11)=  4.0*ETA*RZ2
      DNDXI(6) =  0.0
      DNDXI(12)= -4.0*ETA*RZ2
c <dN/dETA>    
      DNDETA(1) = ( 1.0-4.0*RM)*RZ1
      DNDETA(7) = -4.0*XXI*RZ1
      DNDETA(2) =  0.0
      DNDETA(8) =  4.0*XXI*RZ1
      DNDETA(3) = (-1.0+4.0*ETA)*RZ1
      DNDETA(9) =  4.0*(RM-ETA)*RZ1
      DNDETA(13)= -(1.0-ZETA*ZETA)
      DNDETA(14)=  0.0
      DNDETA(15)=  (1.0-ZETA*ZETA)
      DNDETA(4) = ( 1.0-4.0*RM)*RZ2
      DNDETA(10)= -4.0*XXI*RZ2
      DNDETA(5) =  0.0
      DNDETA(11)=  4.0*XXI*RZ2
      DNDETA(6) = (-1.0+4.0*ETA)*RZ2
      DNDETA(12)=  4.0*(RM-ETA)*RZ2

c <dN/dZETA>
      DRZ1 = -(1.0-2.0*ZETA)/2.0
      DRZ2 =  (1.0+2.0*ZETA)/2.0
      DNDZETA(1) = -RM*(1.0-2.0*RM)*DRZ1
      DNDZETA(7) = 4.0*XXI*RM*DRZ1
      DNDZETA(2) = -XXI*(1.0-2.0*XXI)*DRZ1
      DNDZETA(8) = 4.0*XXI*ETA*DRZ1
      DNDZETA(3) = -ETA*(1.0-2.0*ETA)*DRZ1
      DNDZETA(9) = 4.0*ETA*RM*DRZ1
      DNDZETA(13)= -2.0*RM*ZETA
      DNDZETA(14)= -2.0*XXI*ZETA
      DNDZETA(15)= -2.0*ETA*ZETA
      DNDZETA(4) = -RM*(1.0-2.0*RM)*DRZ2
      DNDZETA(10)= 4.0*XXI*RM*DRZ2
      DNDZETA(5) = -XXI*(1.0-2.0*XXI)*DRZ2
      DNDZETA(11)= 4.0*XXI*ETA*DRZ2
      DNDZETA(6) = -ETA*(1.0-2.0*ETA)*DRZ2
      DNDZETA(12)= 4.0*ETA*RM*DRZ2
c
      ENDIF
      ENDIF
      ENDIF
      ENDIF
c      
      RETURN
      END
