c      SUBROUTINE SOLVE_CG(SYK,F,U,INDEX2,INDEX5,NSUM,
c     &                    DIAG,DD,T1,T2,T3,T4,IWK)
      SUBROUTINE SOLVE_CG
      use fem_arrays
      implicit integer (i-n)
      implicit double precision (a-h,o-z)
C parameters
c      FCON=1.5; DCON=0.1; EPS=1.0E-6 ! EPS=1.0E-4
ccc max. interation number
c      MITR = 100
c      NITR = 0; isel = 0; err = 0
ccc ICCG method 
c      CALL FEMCG3(NTN,NSYK,SYK,F,U,INDEX2,INDEX5,NSUM,IWK,FCON,
c     &   DCON,EPS,MITR,ERR,NITR,CONST,0,DIAG,DD,T1,T2,T3,T4)
      CALL FEMCG3
c
      WRITE(6,9000) CONST,NITR,ERR
 9000 FORMAT(/8X,' CONSTANT USED        : ',F10.1/,
     1       8X,' NUMBER OF ITERATIONS : ',I10/,
     2       8X,' REDISUAL ERROR       : ',E15.6/)
c
      DO 100 I=1,NTN
        DXX=U(3*I-2)
        DYY=U(3*I-1)
        DZZ=U(3*I  )
c        WRITE(6,1100) I,DX,DY,DZ
  100 CONTINUE
 1000 FORMAT(//4X,' SOLUTION BY ',A30,//4X,' NODE',
     1        ' DISPLACEMENT-X DISPLACEMENT-Y DISPLACEMENT-Z'/)
 1100 FORMAT(4X,I5,3E15.6)
c
c       DO 300 I = 1,NTF
c          U(I)=F(I)
c          write(886,1111)F(I)
c 300   CONTINUE
c 1111  format(e17.9)
c
      RETURN
      END
