cc For 3D version
      SUBROUTINE DATA(A,NMTE,ECON,T,NN,X,Y,Z
     + ,IFOR,FB,IDIS,UB,NGNG,NOM,IECON)
      INCLUDE 'para.inc'
      INCLUDE 'const.inc'
      DIMENSION NMTE(*),NN(INMTE,*),X(*),Y(*),Z(*),IFOR(*),IDIS(*)
     +    ,FB(*),UB(*),NOM(*),ECON(9,*),NGNG(*),IECON(*)
      OPEN(1,FILE='input.dat')
C     CHARACTER *1 A(72)
C     READ(5,1)A
C     1 FORMAT(72A1)
C     WRITE(6,1)A
      READ(1,*)NGAUSS
c MNUM : kind of materials
      READ(1,*)MNUM
C+++++++++++++++++++++++++++++++++++++
      write(77,*)'DATA CHECK'
      write(77,*)'NUMBER OF MATERIAL =   ',MNUM
      write(77,*)'INTEGRATION ORDER =    ',NGAUSS
C+++++++++++++++++++++++++++++++++++++
C     READ(1,*)NPARA,T,MNUM
C--ANALYSIS CONDITION------------
C NPARA=0 --> PLANE STRESS
C NPARA=1 --> PLANE STRAIN
C NPARA=2 --> AXIAL SYMMETRY
C--------------------------------
C*ELASTIC CONSTANTS 
C  IECON = 1 --> ISOTROPIC
C    ECON(1,L)=YOUNG MODULE , ECON(2,L)=POISSON RATIO
C  IECON = 2 --> ANISOTROPIC
C    ECON(1,L)=C11 ECON(2,L)=C22 ECON(3,L)=C33 ECON(4,L)=C44 
C    ECON(5,L)=C55 ECON(6,L)=C66 ECON(7,L)=C12 ECON(8,L)=C13 
C    ECON(9,L)=C23  12->4 13->5 23->6
C
      DO 5 L=1,MNUM
	 READ(1,*)IECON(L)
         IEC = IECON(L)
	 IF (IEC.EQ.1)  THEN
            READ(1,*)MN,ECON(1,L),ECON(2,L)
C+++++++++++++++++++++++++++++++++++++
          write(77,*)'Material',L
          write(77,*)'YOUNG=',ECON(1,L),', POISSON=',ECON(2,L)
C+++++++++++++++++++++++++++++++++++++
         ELSE
	 IF (IEC.EQ.2)  THEN
           READ(1,*)MN,ECON(1,L),ECON(2,L),ECON(3,L)
     +                ,ECON(4,L),ECON(5,L),ECON(6,L)
     +                ,ECON(7,L),ECON(8,L),ECON(9,L)
C+++++++++++++++++++++++++++++++++++++
          write(77,*)'Material',L
      write(77,*)'C11=',ECON(1,L),', C22=',ECON(2,L),', C33=',ECON(3,L)
      write(77,*)'C44=',ECON(4,L),', C55=',ECON(5,L),', C66=',ECON(6,L)
      write(77,*)'C12=',ECON(7,L),', C13=',ECON(8,L),', C23=',ECON(9,L)
         ENDIF
         ENDIF
 5    CONTINUE
      READ(1,*)NTN,NTE
c--------------------------------------
c NTN : NUMBER OF NODE
c NTE : NUMBER OF ELEMENT
c NTF : NUMBER OF FREEDOM
c NNA : NUMBER OF INTEGRATION POINT
c--------------------------------------
      NTF=NTN*IDIM
C+++++++++++++++++++++++++++++++++++++++++
      write(77,*)'TOTAL NODES    =   ',NTN
      write(77,*)'TOTAL ELEMENTS =   ',NTE
      write(77,*)'TOTAL FREEDOMS =   ',NTF
C+++++++++++++++++++++++++++++++++++++++++
      NNA=0
      DO 20 IE=1,NTE
         READ(1,*)I,NOM(IE),NMTE(IE)
c---- 6 nodes sankaku-tyu
         IF(NMTE(IE).EQ.6) THEN
          IF (NGAUSS.EQ.1) NGNG(IE)=2
          IF (NGAUSS.EQ.2) NGNG(IE)=6
           READ(1,*)NN(1,IE),NN(2,IE),NN(3,IE),NN(4,IE),
     +              NN(5,IE),NN(6,IE)
C++++++++++++++++++++++++++++++++++++++++
          write(77,*)'ELEMENT',IE,':  MATERIAL',NOM(IE)
     +                                ,' : 6 NODES sankaku-tyuu'
C+++++++++++++++++++++++++++++++++++++++++
c---- 15 nodes sankaku-tyu
         ELSE IF(NMTE(IE).EQ.15) THEN
           READ(1,*)NN(1,IE),NN(2,IE),NN(3,IE),NN(4,IE),
     +              NN(5,IE),NN(6,IE),NN(7,IE),NN(8,IE), 
     +              NN(9,IE),NN(10,IE),NN(11,IE),NN(12,IE), 
     +              NN(13,IE),NN(14,IE),NN(15,IE) 
c******* NGAUSS= 2 or 3
          IF (NGAUSS.EQ.2) NGNG(IE)=6
          IF (NGAUSS.EQ.3) NGNG(IE)=12             
C++++++++++++++++++++++++++++++++++++++++
          write(77,*)'ELEMENT',IE,':  MATERIAL',NOM(IE)
     +                      ,' : 15 NODES sankaku-tyuu'
C+++++++++++++++++++++++++++++++++++++++++
c---- 8 nodes 8-men-tai
         ELSE IF(NMTE(IE).EQ.8) THEN
           READ(1,*)NN(1,IE),NN(2,IE),NN(3,IE),NN(4,IE),
     +              NN(5,IE),NN(6,IE),NN(7,IE),NN(8,IE) 
c******* NGAUSS= 2 or 3
           NGNG(IE)=NGAUSS*NGAUSS*NGAUSS
C++++++++++++++++++++++++++++++++++++++++
          write(77,*)'ELEMENT',IE,':  MATERIAL',NOM(IE)
     +                               ,' : 8 NODES 8-mentai'
C+++++++++++++++++++++++++++++++++++++++++
c---- 20 nodes 8-men-tai
         ELSE IF(NMTE(IE).EQ.20) THEN
           READ(1,*)NN(1,IE),NN(2,IE),NN(3,IE),NN(4,IE),
     +              NN(5,IE),NN(6,IE),NN(7,IE),NN(8,IE),
     +              NN(9,IE),NN(10,IE),NN(11,IE),NN(12,IE), 
     +              NN(13,IE),NN(14,IE),NN(15,IE),NN(16,IE),
     +              NN(17,IE),NN(18,IE),NN(19,IE),NN(20,IE)  
c******* NGAUSS= 2 or 3
           NGNG(IE)=NGAUSS*NGAUSS*NGAUSS 
C+++++++++++++++++++++++++++++++++++++++++         
          write(77,*)'ELEMENT',IE,':  MATERIAL',NOM(IE)
     +                               ,' : 20 NODES 8-mentai'
C+++++++++++++++++++++++++++++++++++++++++         
         ENDIF
         NNA=NNA+NGNG(IE)
 20   CONTINUE
C+++++++++++++++++++++++++++++++++++++++++
        write(77,*)'TOTAL INT.POINTS =   ',NNA
        write(77,*)'COORDINATE OF NODES'
C+++++++++++++++++++++++++++++++++++++++++         
      DO 40 I=1,NTN
         READ(1,*)J,X(I),Y(I),Z(I)
         write(77,112)I,X(I),Y(I),Z(I)
 40   CONTINUE
C+++++++++++++++++++++++++++++++++++++++++
 112  format(I3,3e15.7)
c      
      READ(1,*)NTFOR
      IF(NTFOR.LT.1) GO TO 51
      DO 50 I=1,NTFOR
         READ(1,*)IFOR(I),FB(I)
         IXY=MOD(IFOR(I),IDIM)
         IFN = INT((IFOR(I)+2)/IDIM)
         IF (IXY.EQ.1) WRITE(77,*)'NODE',IFN,'-->FX=',FB(I)
         IF (IXY.EQ.2) WRITE(77,*)'NODE',IFN,'-->FY=',FB(I)
         IF (IXY.EQ.0) WRITE(77,*)'NODE',IFN,'-->FZ=',FB(I)
 50   CONTINUE
 51   CONTINUE
      READ(1,*)NTDIS
      DO 60 I=1,NTDIS
         READ(1,*)IDIS(I),UB(I)
         IXY=MOD(IDIS(I),IDIM)
         IFN = INT((IDIS(I)+2)/IDIM)
         IF (IXY.EQ.1) WRITE(77,*)'NODE',IFN,'-->UX=',UB(I)
         IF (IXY.EQ.2) WRITE(77,*)'NODE',IFN,'-->UY=',UB(I)
         IF (IXY.EQ.0) WRITE(77,*)'NODE',IFN,'-->UZ=',UB(I)
 60   CONTINUE
      CLOSE(1)
c      
      RETURN
      END
