      SUBROUTINE DMAT
      use fem_arrays
      implicit integer (i-n)
      implicit double precision (a-h,o-z)
c      INCLUDE 'para.inc'
c      INCLUDE 'const.inc'
c
cccc 3DIMENSIONAL D-MATRIX
c  K : material number
      K=NOM(IE)
      IECK = IECON(K)
c
      DO 10 I=1,ICOM
       DO 12 JJ=1,ICOM
	D(I,JJ)=0.0
 12    CONTINUE
 10   CONTINUE
c
cccc isotropic
      IF (IECK.EQ.1) THEN
       EYO=ECON(1,K)
       EPO=ECON(2,K)
c
      ESS = EYO*(1.0-EPO)/(1.0+EPO)/(1.0-2.0*EPO)
      C44 = (1.0-2.0*EPO)/2.0/(1.0-EPO)*ESS
      C12 = EPO/(1.0-EPO)*ESS
c
      DO 15 II = 1,3
         D(II,II)=ESS
         D(II+3,II+3)=C44
 15   CONTINUE   
c
	 D(1,2)=C12
	 D(2,1)=C12
         D(1,3)=C12
         D(3,1)=C12
	 D(2,3)=C12
	 D(3,2)=C12
      ENDIF
C
cccc anisotropic
      IF (IECK.EQ.2) THEN
C
       DO 20 I=1,6
         D(I,I)=ECON(I,K)
 20    CONTINUE
C
         D(1,2)=ECON(7,K)
         D(1,3)=ECON(8,K)
         D(2,3)=ECON(9,K)
         D(2,1)=D(1,2)
         D(3,1)=D(1,3)
         D(3,2)=D(2,3)
       ENDIF
C      
      RETURN
      END                          
      
