      PROGRAM LINEPLOT
c
      INCLUDE 'para.inc'
      INCLUDE 'const.inc'
c
      DIMENSION U(IGK),SG(ICOM,IELM,IRD),EP(ICOM,IELM,IRD)
      DIMENSION NEUS(INODE),NNUS(IELM)
      DIMENSION SGN(ICOM,INODE),EPN(ICOM,INODE)
      DIMENSION NLINE1(INODE),NLINE2(INODE)
      DIMENSION X(INODE),Y(INODE),Z(INODE)
c
      IN=0
c
c------- read post file -----------------------start
      OPEN(2,file='result.dat')
c
      READ(2,*)
      READ(2,*)NTN,NTE,NGNG
      READ(2,*)
      READ(2,*)
c
c
cccc nodal displacement
      DO 10 I=1,NTN
      I1 = (I-1)*IDIM + 1
      I2 = (I-1)*IDIM + 2
      I3 =  I*IDIM
      READ(2,100)NNUS(I),U(I1),U(I2),U(I3)
c      write(6,100)NNUS(I),U(I1),U(I2),U(I3)
 100  FORMAT(1H ,I5,3(1X,E15.7))

 10   CONTINUE
c
c
      READ(2,*)
      READ(2,*)
c
      DO 20 IN=1,NTE
      DO 25 KK=1,NGNG
      READ(2,201)NEUS(I),KK,(SG(L,IN,KK),L=1,ICOM)
 25   CONTINUE
 20   CONTINUE
c
      READ(2,*)
      READ(2,*)
c
      DO 30 IN=1,NTE
      DO 35 KK=1,NGNG
      READ(2,201)NEUS(I),KK,(EP(L,IN,KK),L=1,ICOM)
 35   CONTINUE
 30   CONTINUE
C
c----------------------------------------------------------------
c    AVERAGED AT NODE
c----------------------------------------------------------------
      READ(2,*)
      DO 300 IN=1,NTN
          READ(2,211)NNUS(IN),(SGN(L,IN),L=1,ICOM)
 300  CONTINUE
c      
      READ(2,*)
      READ(2,*)
      DO 310 IN=1,NTN
        READ(2,211)NNUS(IN),(EPN(L,IN),L=1,ICOM)
 310  CONTINUE
c
 211  FORMAT(1H I5,6(1X,E15.7),I2)
c----------------------------------------------------------------
 201  FORMAT(1H ,2I5,6(1X,E15.7))
 200  FORMAT(1H ,I5,6(1X,E15.7))
c
      read(2,*)
      read(2,*)
ccccc NODE COORDINATE
      DO 250 II = 1,NTN
      read(2,335)NNUS(II),X(II),Y(II),Z(II)
 250  CONTINUE
c
 335  FORMAT(1H ,I5,3(1X,E15.7))

c
c------- read post file -----------------------end
c
c----  Line Plot --------
c
      write(6,*)'Input plot variable, disp(1),stress(2),strain(3)?'
      write(6,*)'line1.dat --> lplot1.dat'
      write(6,*)'line2.dat --> lplot2.dat'
      read(5,*)ip
c
      open(10,file='line1.dat')
      open(11,file='line2.dat')
c
      open(20,file='lplot1.dat')
      open(21,file='lplot2.dat')
c
      I1 = 0
      DO 400 I = 1,NTN
         read(10,*,end=410)nline1(i)
         I1 = I1 + 1
 400  continue
 410  continue
c
      I2 = 0
      DO 500 I = 1,NTN
         read(11,*,end=510)nline2(i)
         I2 = I2 + 1
 500  continue
 510  continue
c
c      write(6,*)I1,I2
c
ccccc Line1
      DO  600 I = 1,I1
ccccc node number
         KK = nline1(i)
         DO 700 K = 1,NTN
           JJ = NNUS(K)
         IF (JJ.EQ.KK) THEN
            II = (K-1)*IDIM 
cccc displacement
         IF (IP.EQ.1)
     &  write(20,1234)JJ,X(K),Y(K),Z(K),U(II+1),U(II+2),U(II+3)
cccc stress
         IF (IP.EQ.2)
     &  write(20,1235)JJ,X(K),Y(K),Z(K),(SGN(IK,K),IK=1,ICOM)
cccc strain
         IF (IP.EQ.3)
     &  write(20,1235)JJ,X(K),Y(K),Z(K),(EPN(IK,K),IK=1,ICOM)
         GO TO 710
         ELSE
         ENDIF
 700  CONTINUE
      write(6,*)'ERROR'
 710  CONTINUE
 600  CONTINUE
c
ccccc Line2
      DO  601 I = 1,I2
ccccc node number
         KK = nline2(i)
         DO 701 K = 1,NTN
           JJ = NNUS(K)
         IF (JJ.EQ.KK) THEN
            II = (K-1)*IDIM 
cccc displacement
         IF (IP.EQ.1)
     &  write(21,1234)JJ,X(K),Y(K),Z(K),U(II+1),U(II+2),U(II+3)
cccc stress
         IF (IP.EQ.2)
     &  write(21,1235)JJ,X(K),Y(K),Z(K),(SGN(IK,K),IK=1,ICOM)
cccc strain
         IF (IP.EQ.3)
     &  write(21,1235)JJ,X(K),Y(K),Z(K),(EPN(IK,K),IK=1,ICOM)
         GO TO 711
         ELSE
         ENDIF
 701  CONTINUE
      write(6,*)'ERROR-no corresponding node'
      stop
 711  CONTINUE
 601  CONTINUE
c
 1234 format(I5,6e17.9)
 1235 format(I5,9e17.9)
c
      STOP
      END
