      implicit integer (i-n)
      implicit double precision (a-h,o-z)
c----------------------------------------------------------------------
c  IELM  : Max. number of an element 
c  INODE : Max. number of a node
c  IRD   : Max. number of integration point in a element
c  IGK   : Max. size of stiffness matrix  INODE*IDIM
c  IBN   : Max. size of half band width
c  IBOUND: Max. number of constrain (force and displacement)
c  INA   : Max. number of integration point  IELM*IRD
c  INMTE : Max. number of a node in a element --> 8
c  INMNM : Max. size of element stiffness matrix  INMTE*IDIM
c  IMNUM : Max. number of the kind of material 
c  IDM   : DIMENSION
c  ICOM  : number of stress component (2-Dim->4 ,3Dim->6)
c----------------------------------------------------------------------
ccc 3D-8node-2*2*2 integration
c      PARAMETER (IELM=1000,INODE=1000,IRD=8,IGK=3000,IBN=100,IBOUND=100,
c     +     INA=8000,INMTE=8,INMNM=24,IMNUM=10)
      PARAMETER (IELM=2500,INODE=2500,IRD=8,IGK=7500,IBN=1500
     +     ,IBOUND=3000,INA=20000,INMTE=8,INMNM=24,IMNUM=10)
cccc 3D-20node-3*3*3 integration
c      PARAMETER (IELM=1000,INODE=3000,IRD=27,IGK=9000,IBN=300,
c     +     IBOUND=100,INA=27000,INMTE=20,INMNM=60,IMNUM=10)
c      PARAMETER (IELM=1000,INODE=3000,IRD=20,IGK=9000,IBN=300,
c     +     IBOUND=100,INA=27000,INMTE=20,INMNM=60,IMNUM=10)
      PARAMETER (IDIM=3,ICOM=6)

