c      SUBROUTINE SOLVE_C(SYK,INDEX2,INDEX5,NSUM)
      SUBROUTINE SOLVE_C
c      SUBROUTINE SOLVE_C(GK,GKC,F,U,DR,ZM)
      use fem_arrays
      implicit integer (i-n)
      implicit double precision (a-h,o-z)     
c      INCLUDE 'para.inc'
c      INCLUDE 'const.inc'
c      INCLUDE 'femcg.inc'
c      DIMENSION GK(IGK,*),F(*),U(*),P(100)
c      DIMENSION GK(NTF,*),F(*),U(*),P(IBN*2)
c      DIMENSION GK(NTF,*),F(*),U(*)
c      DIMENSION GK(NTF,*)
cccc for ICCG method
c      DIMENSION SYK(*)
c      DIMENSION INDEX2(*),INDEX5(*),NSUM(*)
c     NSMALL(*),NSNODE(INODE,*)
c      DIMENSION GKC(NB,*),DR(*),ZM(*)
cccc for sparce matrix
c
      IX2 = 0
      IC = 0
      DO 100 I = 1,NTN
        K = NSMALL(I)
       IF (K.EQ.0) THEN
          I1 = 3*(I-1) + 1
          I2 = 3*(I-1) + 2
          I3 = 3*(I-1) + 3
          SYK(IC+1) = GK(I1,I1-I1+1)
          SYK(IC+2) = GK(I1,I2-I1+1)
          SYK(IC+3) = GK(I2,I2-I2+1)
          SYK(IC+4) = GK(I1,I3-I1+1)
          SYK(IC+5) = GK(I2,I3-I2+1)
          SYK(IC+6) = GK(I3,I3-I3+1)
          INDEX2(IX2+1) = IC + 1
          INDEX2(IX2+2) = IC + 3
          INDEX2(IX2+3) = IC + 6
          IC = IC + 6
          IX2 = IX2 + 3
       ELSE
cccc x row
          DO 200 J = 1,K
             II = NSNODE(I,J)
cccc check NSNODE !!!
             I1 = 3*(I-1) + 1
             J1 = 3*(II-1)+ 1
             J2 = 3*(II-1)+ 2
             J3 = 3*(II-1)+ 3
             SYK(IC+1) = GK(J1,I1-J1+1)
             SYK(IC+2) = GK(J2,I1-J2+1)
             SYK(IC+3) = GK(J3,I1-J3+1)
             IC = IC + 3 
 200      CONTINUE
             SYK(IC+1) = GK(I1,I1-I1+1)            
             INDEX2(IX2+1) = IC + 1
c
             IC = IC + 1
             IX2 = IX2 + 1
c
cccc y row
          DO 210 J = 1,K
             II = NSNODE(I,J)
             I1 = 3*(I-1) + 1
             I2 = 3*(I-1) + 2
             J1 = 3*(II-1)+ 1
             J2 = 3*(II-1)+ 2
             J3 = 3*(II-1)+ 3
             SYK(IC+1) = GK(J1,I2-J1+1)
             SYK(IC+2) = GK(J2,I2-J2+1)
             SYK(IC+3) = GK(J3,I2-J3+1)
             IC = IC + 3 
 210      CONTINUE
             SYK(IC+1) = GK(I1,I2-I1+1)            
             SYK(IC+2) = GK(I2,I2-I2+1)            
             INDEX2(IX2+1) = IC + 2
             IC = IC + 2 
             IX2 = IX2 + 1
cccc z row
          DO 220 J = 1,K
             II = NSNODE(I,J)
             I1 = 3*(I-1) + 1
             I2 = 3*(I-1) + 2
             I3 = 3*(I-1) + 3
             J1 = 3*(II-1)+ 1
             J2 = 3*(II-1)+ 2
             J3 = 3*(II-1)+ 3
             SYK(IC+1) = GK(J1,I3-J1+1)
             SYK(IC+2) = GK(J2,I3-J2+1)
             SYK(IC+3) = GK(J3,I3-J3+1)
             IC = IC + 3 
 220      CONTINUE
             SYK(IC+1) = GK(I1,I3-I1+1)
             SYK(IC+2) = GK(I2,I3-I2+1)
             SYK(IC+3) = GK(I3,I3-I3+1)
             INDEX2(IX2+1) = IC + 3
             IC = IC + 3 
             IX2 = IX2 + 1
          ENDIF
 100      CONTINUE
c
cccc NSUM , INDEX5
       IX5  =  0
       NSUM(1) = 0
       DO 300 I = 2,NTN
        K = NSMALL(I)
        NSUM(I) = NSUM(I-1)+K
        IF (K.EQ.0) goto 300
        DO 400 J = 1,K
         II = NSNODE(I,J)
         INDEX5(IX5+1) = II
         IX5 = IX5 + 1
 400    CONTINUE
 300   CONTINUE
c
       NSYK = IC
ccc-----output-------
c       write(888,*)IC
c       write(888,1111)(SYK(K),k=1,IC)
c 1111  format(6e17.9)
c       write(887,*)'INDEX2',IX2
c       write(887,*)IX2
c       write(887,1112)(INDEX2(L),L=1,IX2)
c 1112  format(6I7)
c       write(887,*)'NSUM',NTN
c       write(887,1113)(I,NSUM(I),I=1,NTN)
c 1113  format(2I7)
c       write(887,*)'INDEX5',IX5
c       write(887,1114)(I,INDEX5(I),I=1,IX5)
c 1114  format(2I7)
ccc-----output-------
c
c       stop
c
c---original--------original--------original-----
c*       DO 900 J = 1,NTF
c*         DO 800 I = 1,NB
c*            IF ((I+J).LE.NB) THEN
c*              GKC(I,J)=0.0d0
c*            ELSE
c*            i1 = NB + 1 - I
c*            i2 = J + 1 - i1
c*            GKC(I,J)=GK(i2,i1)
c*            ENDIF
c* 800     CONTINUE
c* 900   CONTINUE
c*c
c*c
c*       NUD = NB -1
c*       CALL LISB(GKC,NTF,NUD,NB,F,EPS,DR,ZM,IER)
c*c---original--------original--------original-----
c
c       CALL SBSUB(GKC,NTF,NUD,NB,F,DR,ZM)
c
c       DO 300 I = 1,NTF
c          U(I)=F(I)
c300   CONTINUE
c
      RETURN
      END
